"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.css = css;
Object.defineProperty(exports, "plugin", {
  enumerable: true,
  get: function () {
    return _index.default;
  }
});
exports.styled = styled;
var _react = require("react");
var _reactNative = require("react-native");
var _reactNativeUnistyles = require("react-native-unistyles");
var _index = _interopRequireDefault(require("./plugin/index.js"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
/* ------------------------------------------------------------------ */
/* tipagens utilitárias                                               */
/* ------------------------------------------------------------------ */

/** Pedaços da tag-template: primeiro array de strings + …expressions */

/** Função de interpolação que enxerga `theme` (e eventuais props) */

/* ------------------------------------------------------------------ */
/* styled                                                             */
/* ------------------------------------------------------------------ */

function WithStyled(component) {
  const base = (..._) => component;
  base.attrs = function (attrs) {
    return _ => /*#__PURE__*/(0, _react.createElement)(component, attrs);
  };
  return base;
}
function styled(component) {
  return WithStyled(component);
}

/* ------------------------------------------------------------------ */
/* css – agora tipado e levando theme                                 */
/* ------------------------------------------------------------------ */

function css(..._) {
  // marcador para o plugin Babel; substituído em build-time
  return null;
}

/* ------------------------------------------------------------------ */
/* extras                                                             */
/* ------------------------------------------------------------------ */

styled.attrs = function (attrs) {
  return component => /*#__PURE__*/(0, _react.createElement)(component, attrs);
};
styled.View = WithStyled(_reactNative.View);
styled.Text = WithStyled(_reactNative.Text);
styled.FlatList = WithStyled(_reactNative.FlatList);
styled.SectionList = WithStyled(_reactNative.SectionList);
styled.VirtualizedList = WithStyled(_reactNative.VirtualizedList);
styled.Pressable = WithStyled(_reactNative.Pressable);
styled.ScrollView = WithStyled(_reactNative.ScrollView);
styled.KeyboardAvoidingView = WithStyled(_reactNative.KeyboardAvoidingView);
styled.SafeAreaView = WithStyled(_reactNative.SafeAreaView);
styled.Image = WithStyled(_reactNative.Image);
styled.ImageBackground = WithStyled(_reactNative.ImageBackground);
styled.TextInput = WithStyled(_reactNative.TextInput);
styled.ActivityIndicator = WithStyled(_reactNative.ActivityIndicator);
styled.Button = WithStyled(_reactNative.Button);
styled.Modal = WithStyled(_reactNative.Modal);
styled.StatusBar = WithStyled(_reactNative.StatusBar);
styled.Switch = WithStyled(_reactNative.Switch);
styled.TouchableHighlight = WithStyled(_reactNative.TouchableHighlight);
styled.TouchableOpacity = WithStyled(_reactNative.TouchableOpacity);
styled.TouchableWithoutFeedback = WithStyled(_reactNative.TouchableWithoutFeedback);
styled.RefreshControl = WithStyled(_reactNative.RefreshControl);
styled.createComponent = function (component, styles) {
  return ({
    children,
    style: componentStyle,
    ...rest
  }) => {
    const dynamicStyle = typeof styles === 'function' ? styles(rest) : styles || {};
    const style = _reactNativeUnistyles.StyleSheet.flatten([componentStyle, dynamicStyle]);
    const styledComponent = styled[component];
    return /*#__PURE__*/(0, _react.createElement)(
    // @ts-ignore – resolvido em runtime
    styledComponent ? styledComponent`` : component, {
      ...rest,
      style
    }, children);
  };
};
//# sourceMappingURL=index.js.map