"use strict";

var _core = require("@babel/core");
var _nodeFs = require("node:fs");
var _nodePath = _interopRequireDefault(require("node:path"));
var _index = _interopRequireDefault(require("../index.js"));
var _typescript = _interopRequireDefault(require("typescript"));
function _interopRequireDefault(e) { return e && e.__esModule ? e : { default: e }; }
const config = {
  filename: 'styles.js',
  // Preset env cobre recursos ES7
  presets: [['@babel/preset-env', {
    targets: {
      chrome: '97',
      firefox: '96',
      safari: '15.4',
      node: '16.14'
    },
    modules: false,
    useBuiltIns: false,
    bugfixes: false
  }]],
  // Plugins específicos do ES7 que você talvez queira incluir
  plugins: [_index.default]
};
const tsCode = (0, _nodeFs.readFileSync)(_nodePath.default.join(__dirname, 'styles.ts'), 'utf-8');
const jsCode = _typescript.default.transpileModule(tsCode, {
  compilerOptions: {
    module: _typescript.default.ModuleKind.ESNext,
    target: _typescript.default.ScriptTarget.ESNext,
    importHelpers: false,
    noEmitHelpers: true
  }
});
const result = (0, _core.transformSync)(jsCode.outputText, {
  ...config,
  sourceType: 'module'
});
(0, _nodeFs.writeFileSync)(_nodePath.default.join(__dirname, 'styles.js'), result?.code || '');
//# sourceMappingURL=styles.test.js.map