"use strict";

import { createElement } from 'react';
import { ActivityIndicator, Button, FlatList, Image, ImageBackground, KeyboardAvoidingView, Modal, Pressable, RefreshControl, SafeAreaView, ScrollView, SectionList, StatusBar, Switch, Text, TextInput, TouchableHighlight, TouchableOpacity, TouchableWithoutFeedback, View, VirtualizedList } from 'react-native';
import { StyleSheet } from 'react-native-unistyles';

/* ------------------------------------------------------------------ */
/* tipagens utilitárias                                               */
/* ------------------------------------------------------------------ */

/** Pedaços da tag-template: primeiro array de strings + …expressions */

/** Função de interpolação que enxerga `theme` (e eventuais props) */

/* ------------------------------------------------------------------ */
/* styled                                                             */
/* ------------------------------------------------------------------ */

function WithStyled(component) {
  const base = (..._) => component;
  base.attrs = function (attrs) {
    return _ => /*#__PURE__*/createElement(component, attrs);
  };
  return base;
}
export function styled(component) {
  return WithStyled(component);
}

/* ------------------------------------------------------------------ */
/* css – agora tipado e levando theme                                 */
/* ------------------------------------------------------------------ */

export function css(..._) {
  // marcador para o plugin Babel; substituído em build-time
  return null;
}

/* ------------------------------------------------------------------ */
/* extras                                                             */
/* ------------------------------------------------------------------ */

styled.attrs = function (attrs) {
  return component => /*#__PURE__*/createElement(component, attrs);
};
styled.View = WithStyled(View);
styled.Text = WithStyled(Text);
styled.FlatList = WithStyled(FlatList);
styled.SectionList = WithStyled(SectionList);
styled.VirtualizedList = WithStyled(VirtualizedList);
styled.Pressable = WithStyled(Pressable);
styled.ScrollView = WithStyled(ScrollView);
styled.KeyboardAvoidingView = WithStyled(KeyboardAvoidingView);
styled.SafeAreaView = WithStyled(SafeAreaView);
styled.Image = WithStyled(Image);
styled.ImageBackground = WithStyled(ImageBackground);
styled.TextInput = WithStyled(TextInput);
styled.ActivityIndicator = WithStyled(ActivityIndicator);
styled.Button = WithStyled(Button);
styled.Modal = WithStyled(Modal);
styled.StatusBar = WithStyled(StatusBar);
styled.Switch = WithStyled(Switch);
styled.TouchableHighlight = WithStyled(TouchableHighlight);
styled.TouchableOpacity = WithStyled(TouchableOpacity);
styled.TouchableWithoutFeedback = WithStyled(TouchableWithoutFeedback);
styled.RefreshControl = WithStyled(RefreshControl);
styled.createComponent = function (component, styles) {
  return ({
    children,
    style: componentStyle,
    ...rest
  }) => {
    const dynamicStyle = typeof styles === 'function' ? styles(rest) : styles || {};
    const style = StyleSheet.flatten([componentStyle, dynamicStyle]);
    const styledComponent = styled[component];
    return /*#__PURE__*/createElement(
    // @ts-ignore – resolvido em runtime
    styledComponent ? styledComponent`` : component, {
      ...rest,
      style
    }, children);
  };
};
export { default as plugin } from "./plugin/index.js";
//# sourceMappingURL=index.js.map