"use strict";

export function Functional(data) {
  /** Flag global para saber se algum .property() disparou */
  let matched = false;

  /** Objeto que vamos devolver em todas as chamadas para manter o encadeamento */
  const chain = {
    /* --------------------------------------------------------- */
    /* .property('key', { is }, cb)                              */
    /* --------------------------------------------------------- */
    property(key, directive, cb) {
      if (data[key] === directive.is) {
        matched = true;
        cb();
      }
      return chain; // permite .property().property().continue()
    },
    /* --------------------------------------------------------- */
    /* .continue(cb) – executa cb se NENHUM .property() bateu    */
    /* --------------------------------------------------------- */
    continue(cb) {
      if (!matched) cb();
      matched = false; // zera para um novo ciclo, se encadear
      return chain;
    },
    /* --------------------------------------------------------- */
    /* .some(directive).then(cb).catch(cb)                       */
    /* --------------------------------------------------------- */
    some(directive) {
      let isTrue = false;
      if (Array.isArray(data)) {
        isTrue = data.some(item => item === directive);
      }
      return {
        then(cb) {
          if (isTrue) cb();
          return this;
        },
        catch(cb) {
          if (!isTrue) cb();
          return this;
        }
      };
    }
  };
  return chain;
}
//# sourceMappingURL=functional.js.map