/*************************************************
 * 1) Definições de tipos para TOKENS
 ************************************************/
export interface Token {
    type: 'identifier' | 'punctuation' | 'number';
    value: string;
    unit?: string;
}
/*************************************************
 * 2) Definições de tipos para a AST
 ************************************************/
export type CSSNode = StyleSheet | Declaration | MediaRule | PseudoRule | MediaCondition | NumberNode;
export interface StyleSheet {
    type: 'StyleSheet';
    body: CSSNode[];
}
export interface Declaration {
    type: 'Declaration';
    property: string;
    value: string;
}
export interface MediaRule {
    type: 'MediaRule';
    condition: MediaCondition;
    declarations: Declaration[];
}
export interface PseudoRule {
    type: 'PseudoRule';
    pseudo: string;
    declarations: Declaration[];
}
export interface MediaCondition {
    type: 'MediaCondition';
    property: string;
    value: NumberNode;
}
export interface NumberNode {
    type: 'Number';
    value: number;
    unit?: string;
}
/*************************************************
 * 3) Parser principal
 ************************************************/
export declare function parseTokensToAST(tokens: Token[]): StyleSheet;
//# sourceMappingURL=parseAST.d.ts.map