import { type ComponentProps, type ComponentType } from 'react';
import { View } from 'react-native';
interface CssStyle extends TemplateStringsArray {
}
/** Pedaços da tag-template: primeiro array de strings + …expressions */
type ArgsComponentStyle<T extends unknown[]> = [CssStyle, ...T];
type Primitive = string | number | object | null | undefined | false;
/** Função de interpolação que enxerga `theme` (e eventuais props) */
type CssInterpolation<P> = Primitive | ((props: P & {
    theme: any;
}) => Primitive);
export declare function styled<T extends ComponentType<any>>(component?: T): {
    <K>(__0: CssStyle, ..._: CssInterpolation<ComponentProps<T> & K>[]): ComponentType<ComponentProps<T> & K>;
    attrs(attrs: ComponentProps<T>): (_: CssStyle) => T;
};
export declare namespace styled {
    var attrs: (attrs: any) => (component: any) => import("react").CElement<any, import("react").Component<any, any, any>>;
    var View: {
        <K>(__0: CssStyle, ..._: CssInterpolation<import("react-native").ViewProps & K>[]): ComponentType<import("react-native").ViewProps & K>;
        attrs(attrs: import("react-native").ViewProps): (_: CssStyle) => typeof import("react-native").View;
    };
    var Text: {
        <K>(__0: CssStyle, ..._: CssInterpolation<import("react-native").TextProps & K>[]): ComponentType<import("react-native").TextProps & K>;
        attrs(attrs: import("react-native").TextProps): (_: CssStyle) => typeof import("react-native").Text;
    };
    var FlatList: {
        <K>(__0: CssStyle, ..._: CssInterpolation<import("react-native").FlatListProps<unknown> & K>[]): ComponentType<import("react-native").FlatListProps<unknown> & K>;
        attrs(attrs: import("react-native").FlatListProps<unknown>): (_: CssStyle) => typeof import("react-native").FlatList;
    };
    var SectionList: {
        <K>(__0: CssStyle, ..._: CssInterpolation<import("react-native").SectionListProps<unknown, unknown> & K>[]): ComponentType<import("react-native").SectionListProps<unknown, unknown> & K>;
        attrs(attrs: import("react-native").SectionListProps<unknown, unknown>): (_: CssStyle) => typeof import("react-native").SectionList;
    };
    var VirtualizedList: {
        <K>(__0: CssStyle, ..._: CssInterpolation<import("react-native").VirtualizedListProps<unknown> & K>[]): ComponentType<import("react-native").VirtualizedListProps<unknown> & K>;
        attrs(attrs: import("react-native").VirtualizedListProps<unknown>): (_: CssStyle) => typeof import("react-native").VirtualizedList;
    };
    var Pressable: {
        <K>(__0: CssStyle, ..._: CssInterpolation<import("react-native").PressableProps & import("react").RefAttributes<View> & K>[]): ComponentType<import("react-native").PressableProps & import("react").RefAttributes<View> & K>;
        attrs(attrs: import("react-native").PressableProps & import("react").RefAttributes<View>): (_: CssStyle) => import("react").ForwardRefExoticComponent<import("react-native").PressableProps & import("react").RefAttributes<View>>;
    };
    var ScrollView: {
        <K>(__0: CssStyle, ..._: CssInterpolation<import("react-native").ScrollViewProps & K>[]): ComponentType<import("react-native").ScrollViewProps & K>;
        attrs(attrs: import("react-native").ScrollViewProps): (_: CssStyle) => typeof import("react-native").ScrollView;
    };
    var KeyboardAvoidingView: {
        <K>(__0: CssStyle, ..._: CssInterpolation<import("react-native").KeyboardAvoidingViewProps & K>[]): ComponentType<import("react-native").KeyboardAvoidingViewProps & K>;
        attrs(attrs: import("react-native").KeyboardAvoidingViewProps): (_: CssStyle) => typeof import("react-native").KeyboardAvoidingView;
    };
    var SafeAreaView: {
        <K>(__0: CssStyle, ..._: CssInterpolation<import("react-native").ViewProps & K>[]): ComponentType<import("react-native").ViewProps & K>;
        attrs(attrs: import("react-native").ViewProps): (_: CssStyle) => typeof import("react-native").SafeAreaView;
    };
    var Image: {
        <K>(__0: CssStyle, ..._: CssInterpolation<import("react-native").ImageProps & K>[]): ComponentType<import("react-native").ImageProps & K>;
        attrs(attrs: import("react-native").ImageProps): (_: CssStyle) => typeof import("react-native").Image;
    };
    var ImageBackground: {
        <K>(__0: CssStyle, ..._: CssInterpolation<import("react-native").ImageBackgroundProps & K>[]): ComponentType<import("react-native").ImageBackgroundProps & K>;
        attrs(attrs: import("react-native").ImageBackgroundProps): (_: CssStyle) => typeof import("react-native").ImageBackground;
    };
    var TextInput: {
        <K>(__0: CssStyle, ..._: CssInterpolation<import("react-native").TextInputProps & K>[]): ComponentType<import("react-native").TextInputProps & K>;
        attrs(attrs: import("react-native").TextInputProps): (_: CssStyle) => typeof import("react-native").TextInput;
    };
    var ActivityIndicator: {
        <K>(__0: CssStyle, ..._: CssInterpolation<import("react-native").ActivityIndicatorProps & K>[]): ComponentType<import("react-native").ActivityIndicatorProps & K>;
        attrs(attrs: import("react-native").ActivityIndicatorProps): (_: CssStyle) => typeof import("react-native").ActivityIndicator;
    };
    var Button: {
        <K>(__0: CssStyle, ..._: CssInterpolation<import("react-native").ButtonProps & K>[]): ComponentType<import("react-native").ButtonProps & K>;
        attrs(attrs: import("react-native").ButtonProps): (_: CssStyle) => typeof import("react-native").Button;
    };
    var Modal: {
        <K>(__0: CssStyle, ..._: CssInterpolation<import("react-native").ModalBaseProps & import("react-native").ModalPropsIOS & import("react-native").ModalPropsAndroid & import("react-native").ViewProps & K>[]): ComponentType<import("react-native").ModalBaseProps & import("react-native").ModalPropsIOS & import("react-native").ModalPropsAndroid & import("react-native").ViewProps & K>;
        attrs(attrs: import("react-native").ModalBaseProps & import("react-native").ModalPropsIOS & import("react-native").ModalPropsAndroid & import("react-native").ViewProps): (_: CssStyle) => typeof import("react-native").Modal;
    };
    var StatusBar: {
        <K>(__0: CssStyle, ..._: CssInterpolation<import("react-native").StatusBarProps & K>[]): ComponentType<import("react-native").StatusBarProps & K>;
        attrs(attrs: import("react-native").StatusBarProps): (_: CssStyle) => typeof import("react-native").StatusBar;
    };
    var Switch: {
        <K>(__0: CssStyle, ..._: CssInterpolation<import("react-native").SwitchProps & K>[]): ComponentType<import("react-native").SwitchProps & K>;
        attrs(attrs: import("react-native").SwitchProps): (_: CssStyle) => typeof import("react-native").Switch;
    };
    var TouchableHighlight: {
        <K>(__0: CssStyle, ..._: CssInterpolation<import("react-native").TouchableHighlightProps & import("react").RefAttributes<View> & K>[]): ComponentType<import("react-native").TouchableHighlightProps & import("react").RefAttributes<View> & K>;
        attrs(attrs: import("react-native").TouchableHighlightProps & import("react").RefAttributes<View>): (_: CssStyle) => import("react").ForwardRefExoticComponent<import("react-native").TouchableHighlightProps & import("react").RefAttributes<View>>;
    };
    var TouchableOpacity: {
        <K>(__0: CssStyle, ..._: CssInterpolation<import("react-native").TouchableOpacityProps & import("react").RefAttributes<View> & K>[]): ComponentType<import("react-native").TouchableOpacityProps & import("react").RefAttributes<View> & K>;
        attrs(attrs: import("react-native").TouchableOpacityProps & import("react").RefAttributes<View>): (_: CssStyle) => import("react").ForwardRefExoticComponent<import("react-native").TouchableOpacityProps & import("react").RefAttributes<View>>;
    };
    var TouchableWithoutFeedback: {
        <K>(__0: CssStyle, ..._: CssInterpolation<import("react-native").TouchableWithoutFeedbackProps & K>[]): ComponentType<import("react-native").TouchableWithoutFeedbackProps & K>;
        attrs(attrs: import("react-native").TouchableWithoutFeedbackProps): (_: CssStyle) => typeof import("react-native").TouchableWithoutFeedback;
    };
    var RefreshControl: {
        <K>(__0: CssStyle, ..._: CssInterpolation<import("react-native").RefreshControlProps & K>[]): ComponentType<import("react-native").RefreshControlProps & K>;
        attrs(attrs: import("react-native").RefreshControlProps): (_: CssStyle) => typeof import("react-native").RefreshControl;
    };
    var createComponent: (component: string, styles: any) => ({ children, style: componentStyle, ...rest }: any) => import("react").DetailedReactHTMLElement<import("react").InputHTMLAttributes<HTMLInputElement>, HTMLInputElement>;
}
export declare function css<P = {}>(..._: ArgsComponentStyle<CssInterpolation<P>[]>): CssInterpolation<P>;
export { default as plugin } from './plugin';
//# sourceMappingURL=index.d.ts.map